#include <jagdefs.h>
#include <jagtypes.h>
#include <stdlib.h>
#include <stdio.h>

#include <interrupt.h>
#include <sprite.h>
#include <joypad.h>
#include <sound.h>
#include <screen.h>
#include <blit.h>
#include <fb2d.h>
#include <render.h>
#include <console.h>

#include "data.h"

#define DEBUG 0

#define SIDESHADING GRDSHADING
//#define SIDESHADING FLTSHADING

#define TEST 2

#undef SET_BG 

#define MUZAK (TEST==2)

#define RED 0xf0ff
#define GREEN 0x7fff
#define BLUE 0x00ff
#define CYAN 0x0fff
#define MAGENTA 0x70ff
#define YELLOW 0xffff
#define WHITE 0x88ff
#define GRAY 0x88c0

#ifndef SET_BG
#define SET_BG(x) {}
#endif

/* #undef GRDSHADING */
/* #undef TXTMAPPING  */

#ifndef GRDSHADING
#define GRDSHADING 0
#endif

#ifndef TXTMAPPING
#define TXTMAPPING 0
#endif

#if(TEST==0) 
#define V1 {0<<16, 0<<16, 150<<16, 20<<16, 0<<16, 0<<16}
#define V2 {10<<16, 319<<16, 150<<16, 40<<16, 63<<16, 0<<16}
#define V3 {190<<16, 319<<16, 150<<16, 50<<16, 63<<16, 63<<16}
#define V4 {200<<16, 0<<16, 150<<16, 50<<16, 0<<16, 63<<16}

polygon symm = {NULL, GRDSHADING|TXTMAPPING, 4, MAGENTA, NULL, {V1, V2, V3, V4}};
#endif

#if(TEST==1)
#define ZOOM 5
#define SCALE 5<<5

#define V_A {(5*ZOOM)<<16, (1*ZOOM)<<16, 40<<16, 10<<16, 0, 0}
#define V_B {(18*ZOOM)<<16, (10*ZOOM)<<16, 80<<16, 20<<16, 0<<16, 0<<16}
#define V_C {(3*ZOOM)<<16, (35*ZOOM)<<16, 120<<16, 30<<16, 0, 0}
#define V_D {(25*ZOOM)<<16, (50*ZOOM)<<16, 50<<16, 40<<16, 63<<16, 0<<16}
#define V_E {(25*ZOOM)<<16, (25*ZOOM)<<16, 60<<16, 50<<16, 63<<16, 63<<16}
#define V_F {(15*ZOOM)<<16, (55*ZOOM)<<16, 70<<16, 60<<16, 0, 0}
#define V_G {(37*ZOOM)<<16, (30*ZOOM)<<16, 80<<16, 55<<16, 0, 0}
#define V_H {(3*ZOOM)<<16, (10*ZOOM)<<16, 140<<16, 50<<16, 0, 0}
#define V1 {0x3a0000, 0xd60000, 0, 10<<16, 0, 0 }
#define V2 {0xae0000, 0xce0000, 0, 10<<16, 0, 0 }
#define V3 {0xac0000, 0xc90000, 0x44880, 15<<16, 0, 0 }
#define V4 {0x370000, 0xd20000, 0xaf6380, 15<<16, 0, 0}

#define NB_VERTICES 12

vertex vertices[NB_VERTICES] = { V_A, V_B, V_C, V_D,
				 V_E, V_F, V_G, V_H,
				 V1, V2, V3, V4};

/* #undef ZBUFFERING */
/* #define ZBUFFERING 0 */

polygon p1 = { NULL, ZBUFFERING|GRDSHADING, 3, RED, NULL, {V_B, V_A, V_C} }; 
polygon p2 = { &p1, ZBUFFERING, 3, GREEN, NULL, {V_C, V_D, V_B} }; 
polygon p3 = { &p2, ZBUFFERING|GRDSHADING|TXTMAPPING, 3, YELLOW, NULL, {V_B, V_D, V_E} };
polygon p4 = { &p3, ZBUFFERING|GRDSHADING, 3, CYAN, NULL, {V_F, V_D, V_C} };
polygon p5 = { &p4, ZBUFFERING|GRDSHADING, 3, BLUE, NULL, {V_D, V_G, V_E} };
polygon p6 = { &p5, ZBUFFERING, 3, MAGENTA, NULL, {V_H, V_F, V_G}};

polygon pa = {NULL, FLTSHADING, 7, MAGENTA, NULL, {V_A, V_C, V_F, V_D, V_G, V_E, V_B}};

polygon ptest = {NULL, ZBUFFERING|GRDSHADING, 4, BLUE, NULL, {V1,V2,V3,V4}};
#endif

#if(TEST==2)
#define V_TEMPL {0, 0, 0, 0, 0, 0}

polygon petiq = {NULL, GRDSHADING|TXTMAPPING, 4, BLUE, NULL, {V_TEMPL, V_TEMPL, V_TEMPL, V_TEMPL}};

polygon pmetal = {&petiq, GRDSHADING, 4, WHITE, NULL, {V_TEMPL, V_TEMPL, V_TEMPL, V_TEMPL}};
polygon pavant = {&pmetal, GRDSHADING, 4, BLUE, NULL, {V_TEMPL, V_TEMPL, V_TEMPL, V_TEMPL}};
polygon parriere = {&pavant, GRDSHADING, 4, BLUE, NULL, {V_TEMPL, V_TEMPL, V_TEMPL, V_TEMPL}};

polygon pside1 = {&parriere, SIDESHADING, 4, BLUE, NULL, {V_TEMPL, V_TEMPL, V_TEMPL, V_TEMPL}};
polygon pside2 = {&pside1, SIDESHADING, 4, BLUE, NULL, {V_TEMPL, V_TEMPL, V_TEMPL, V_TEMPL}};
polygon pside3 = {&pside2, SIDESHADING, 4, BLUE, NULL, {V_TEMPL, V_TEMPL, V_TEMPL, V_TEMPL}};
polygon pside4 = {&pside3, SIDESHADING, 4, BLUE, NULL, {V_TEMPL, V_TEMPL, V_TEMPL, V_TEMPL}};
#endif

screen *texture;

#if(TEST==2)
#define XCoord(idx) (X2D[idx]<<16)
#define YCoord(idx) (Y2D[idx]<<16)

int light = 80<<16;

#define SAT24(x) (x < 0 ? 0 : (x > 0xffffff ? 0xffffff : x))
#define I(idx) (SAT24(light + (Z3D[19+idx]<<7)))
//#define I(idx) ((Z3D[19+idx]<<7))

void switch_flat_mode(int flag) {
  if(flag) {
    petiq.flags = FLTMAPPING|TXTMAPPING;
  } else {
    petiq.flags = TXTMAPPING;
  }
  pmetal.flags = FLTSHADING;
  pavant.flags = FLTSHADING;
  parriere.flags = FLTSHADING;
  pside1.flags = FLTSHADING;
  pside2.flags = FLTSHADING;
  pside3.flags = FLTSHADING;
  pside4.flags = FLTSHADING;
}

void switch_gouraud_mode() {
  petiq.flags = GRDSHADING|TXTMAPPING;
  pmetal.flags = GRDSHADING;
  pavant.flags = GRDSHADING;
  parriere.flags = GRDSHADING;
  pside1.flags = GRDSHADING;
  pside2.flags = GRDSHADING;
  pside3.flags = GRDSHADING;
  pside4.flags = GRDSHADING;
}

void set_object() {
  // face avant
  pavant.vertices[0].x = XCoord(0);
  pavant.vertices[0].y = YCoord(0);
  pavant.vertices[1].x = XCoord(1);
  pavant.vertices[1].y = YCoord(1);
  pavant.vertices[2].x = XCoord(2);
  pavant.vertices[2].y = YCoord(2);
  pavant.vertices[3].x = XCoord(3);
  pavant.vertices[3].y = YCoord(3);

  pavant.vertices[0].i = I(0);
  pavant.vertices[1].i = I(1);
  pavant.vertices[2].i = I(2);
  pavant.vertices[3].i = I(3);

  pavant.param &= 0xff00;
  pavant.param |= (((I(0)+I(1)+I(2)+I(3))>>2) >> 16)  & 0xff;
  // etiquette
  petiq.vertices[0].x = XCoord(4);
  petiq.vertices[0].y = YCoord(4);
  petiq.vertices[1].x = XCoord(5);
  petiq.vertices[1].y = YCoord(5);
  petiq.vertices[2].x = XCoord(6);
  petiq.vertices[2].y = YCoord(6);
  petiq.vertices[3].x = XCoord(7);
  petiq.vertices[3].y = YCoord(7);

  petiq.vertices[0].i = I(4)-(50<<16);
  petiq.vertices[1].i = I(5)-(50<<16);
  petiq.vertices[2].i = I(6)-(50<<16);
  petiq.vertices[3].i = I(7)-(50<<16);

  if(petiq.flags & GRDSHADING) {
    texture->data = &texture_gfx;
  } else {
    texture->data = &texture2_gfx;
  }
  petiq.texture = texture;
  petiq.vertices[0].u = 1<<16;
  petiq.vertices[0].v = 1<<16;
  petiq.vertices[1].u = (TEXTURE_WIDTH-1)<<16;
  petiq.vertices[1].v = 1<<16;
  petiq.vertices[2].u = (TEXTURE_WIDTH-1)<<16;
  petiq.vertices[2].v = (TEXTURE_HEIGHT-1)<<16;
  petiq.vertices[3].u = 1<<16;
  petiq.vertices[3].v = (TEXTURE_HEIGHT-1)<<16;

  petiq.param &= 0xff00;
  petiq.param |= (((I(4)+I(5)+I(6)+I(7))>>2) >> 16)  & 0xff;

  petiq.param = ((I(4)+I(5)+I(6)+I(7))>>2) ^ 0x800000;
  // partie metallique
  pmetal.vertices[0].x = XCoord(8);
  pmetal.vertices[0].y = YCoord(8);
  pmetal.vertices[1].x = XCoord(9);
  pmetal.vertices[1].y = YCoord(9);
  pmetal.vertices[2].x = XCoord(10);
  pmetal.vertices[2].y = YCoord(10);
  pmetal.vertices[3].x = XCoord(11);
  pmetal.vertices[3].y = YCoord(11);

  pmetal.vertices[0].i = I(8);
  pmetal.vertices[1].i = I(9);
  pmetal.vertices[2].i = I(10);
  pmetal.vertices[3].i = I(11);

  pmetal.param &= 0xff00;
  pmetal.param |= (((I(8)+I(9)+I(10)+I(11))>>2) >> 16)  & 0xff;
  // face arriere
  parriere.vertices[0].x = XCoord(15);
  parriere.vertices[0].y = YCoord(15);
  parriere.vertices[1].x = XCoord(18);
  parriere.vertices[1].y = YCoord(18);
  parriere.vertices[2].x = XCoord(17);
  parriere.vertices[2].y = YCoord(17);
  parriere.vertices[3].x = XCoord(16);
  parriere.vertices[3].y = YCoord(16);

  parriere.vertices[0].i = I(15);
  parriere.vertices[1].i = I(18);
  parriere.vertices[2].i = I(17);
  parriere.vertices[3].i = I(16);

  parriere.param &= 0xff00;
  parriere.param |= (((I(15)+I(18)+I(17)+I(16))>>2) >> 16)  & 0xff;
  //
  pside1.vertices[0].x = XCoord(15);
  pside1.vertices[0].y = YCoord(15);
  pside1.vertices[1].x = XCoord(16);
  pside1.vertices[1].y = YCoord(16);
  pside1.vertices[2].x = XCoord(1);
  pside1.vertices[2].y = YCoord(1);
  pside1.vertices[3].x = XCoord(0);
  pside1.vertices[3].y = YCoord(0);

  pside1.vertices[0].i = I(15);
  pside1.vertices[1].i = I(16);
  pside1.vertices[2].i = I(1);
  pside1.vertices[3].i = I(0);

  pside1.param &= 0xff00;
  pside1.param |= (((I(15)+I(16)+I(1)+I(0))>>2) >> 16)  & 0xff;
  //
  pside2.vertices[0].x = XCoord(17);
  pside2.vertices[0].y = YCoord(17);
  pside2.vertices[1].x = XCoord(18);
  pside2.vertices[1].y = YCoord(18);
  pside2.vertices[2].x = XCoord(3);
  pside2.vertices[2].y = YCoord(3);
  pside2.vertices[3].x = XCoord(2);
  pside2.vertices[3].y = YCoord(2);

  pside2.vertices[0].i = I(17);
  pside2.vertices[1].i = I(18);
  pside2.vertices[2].i = I(3);
  pside2.vertices[3].i = I(2);

  pside2.param &= 0xff00;
  pside2.param |= (((I(17)+I(18)+I(3)+I(2))>>2) >> 16)  & 0xff;
  // 
  pside3.vertices[0].x = XCoord(16);
  pside3.vertices[0].y = YCoord(16);
  pside3.vertices[1].x = XCoord(17);
  pside3.vertices[1].y = YCoord(17);
  pside3.vertices[2].x = XCoord(2);
  pside3.vertices[2].y = YCoord(2);
  pside3.vertices[3].x = XCoord(1);
  pside3.vertices[3].y = YCoord(1);

  pside3.vertices[0].i = I(16);
  pside3.vertices[1].i = I(17);
  pside3.vertices[2].i = I(2);
  pside3.vertices[3].i = I(1);

  pside3.param &= 0xff00;
  pside3.param |= (((I(16)+I(17)+I(2)+I(1))>>2) >> 16)  & 0xff;
  //
  pside4.vertices[0].x = XCoord(18);
  pside4.vertices[0].y = YCoord(18);
  pside4.vertices[1].x = XCoord(15);
  pside4.vertices[1].y = YCoord(15);
  pside4.vertices[2].x = XCoord(0);
  pside4.vertices[2].y = YCoord(0);
  pside4.vertices[3].x = XCoord(3);
  pside4.vertices[3].y = YCoord(3);

  pside4.vertices[0].i = I(18);
  pside4.vertices[1].i = I(15);
  pside4.vertices[2].i = I(0);
  pside4.vertices[3].i = I(3);

  pside4.param &= 0xff00;
  pside4.param |= (((I(18)+I(15)+I(0)+I(3))>>2) >> 16)  & 0xff;
}

void draw_object(screen *dst) {
  set_object();
  render_polygon_list(dst,&pside4,CLR_SCREEN);
}
#endif

#if(TEST==1)
void set_polygons() {
  // p1
  p1.vertices[0] = vertices[1];
  p1.vertices[1] = vertices[0];
  p1.vertices[2] = vertices[2];
  // p2 
  p2.vertices[0] = vertices[2];
  p2.vertices[1] = vertices[3];
  p2.vertices[2] = vertices[1];
  // p3
  p3.vertices[0] = vertices[1];
  p3.vertices[1] = vertices[3];
  //  p3.vertices[2] = vertices[6];
  p3.vertices[2] = vertices[4];
  p3.texture = texture;
  // p4
  p4.vertices[0] = vertices[5];
  p4.vertices[1] = vertices[3];
  p4.vertices[2] = vertices[2];
  // p5
  p5.vertices[0] = vertices[3];
  p5.vertices[1] = vertices[6];
  p5.vertices[2] = vertices[4];
  // p6
  p6.vertices[0] = vertices[7];
  p6.vertices[1] = vertices[5];
  p6.vertices[2] = vertices[6];
  // pa
  pa.vertices[0] = vertices[0];
  pa.vertices[1] = vertices[2];
  pa.vertices[2] = vertices[5];
  pa.vertices[3] = vertices[3];
  pa.vertices[4] = vertices[6];
  pa.vertices[5] = vertices[4];
  pa.vertices[6] = vertices[1];
  pa.texture = texture;
  //
  ptest.vertices[0] = vertices[8];
  ptest.vertices[1] = vertices[9];
  ptest.vertices[2] = vertices[10];
  ptest.vertices[3] = vertices[11];
}
#endif

void show_polygon(FILE *console, polygon *p) {
  int i;
  int n = p->size;
  fprintf(console,"%d vertices\n",n);
  for(i = 0; i < n; i++) {
    fprintf(console,"X = %08x\n",p->vertices[i].x);
    fprintf(console,"Y = %08x\n",p->vertices[i].y);
    fprintf(console,"I = %08x\n",p->vertices[i].i);
    fprintf(console,"Z = %08x\n",p->vertices[i].z);
    fprintf(console,"U = %08x\n",p->vertices[i].u);
    fprintf(console,"V = %08x\n",p->vertices[i].v);
  }
}

int main(int argc, char *argv[]) {
  joypad_state *j_state = malloc(sizeof(joypad_state));

  TOMREGS->vmode = CRY16|CSYNC|BGEN|PWIDTH4|VIDEN;
  init_interrupts();

  init_display_driver();

#if MUZAK
  init_sound_driver(40000);

  init_module(&muzaxx,1);
#endif

  display *d = new_display(0);

  d->x = 32;
  d->y = 16;

  texture = new_screen();
  set_simple_screen(DEPTH16,TEXTURE_WIDTH,TEXTURE_HEIGHT,texture,&texture_gfx);

  sprite *texture_sprite = sprite_of_screen(0,0,texture);

/*   texture2 = new_screen(); */
/*   set_simple_screen(DEPTH16,256,192,texture2,&texture2_gfx); */

  screen *frame1 = new_screen();
  screen *frame2 = new_screen();
  phrase *frame_data = alloc_z_double_buffered_screens(DEPTH16,320,240,frame1,frame2);
  sprite *frame_sprite = sprite_of_screen(0,0,frame1);

  frame_sprite->trans = 1;

  void *renderer_addr = &_GPU_FREE_RAM;
  void *gpu_available_ram = init_renderer(renderer_addr);

  //  attach_sprite_to_display_at_layer(texture_sprite,d,15);

  show_display(d);

#if MUZAK
  vblQueue[0] = play_module;
#endif

#if(TEST==2)
  attach_sprite_to_display_at_layer(frame_sprite,d,1);

  screen *phys = frame1;
  screen *log = frame2;
  screen *tmp = phys;

#if(DEBUG)
  FILE *console = open_console(d,0,0,0);
#endif

  clear_screen(frame1);

  init_3D();
  for(;;) {
    vsync();
    SET_BG(RED);
    //    clear_screen(phys);
    SET_BG(BLUE);
    draw_object(phys);
    animate_3D();
    read_joypad_state(j_state);
    SET_BG(YELLOW);
    wait_renderer_completion();
    SET_BG(0);
    tmp = phys;
    phys = log;
    log = tmp;
    wait_display_refresh();
    frame_sprite->data = phys->data;

    if(j_state->j1 & JOYPAD_SHARP) {
      light += 0x10000;
    } else if(j_state->j1 & JOYPAD_STAR) {
      light -= 0x10000;
    }
    if(j_state->j1 & JOYPAD_X) {
      switch_flat_mode(0);
    } else if(j_state->j1 & JOYPAD_Y) {
      switch_flat_mode(1);
    } else if(j_state->j1 & JOYPAD_Z) {
      switch_gouraud_mode();
    }

#if(DEBUG)
    if(pause) {
      if(j_state->j1 & JOYPAD_OPTION) {
	int i;
	for(i = 0; i < 19; i++) {
	  fprintf(console,"int[%d] = %08x\n",i,I(i));
	}
	fprintf(console,"light=%08x\n",light);
	show_polygon(console,&pside4);
      }
      if(j_state->j1 & JOYPAD_UP) {
	A+=2;
	if(A > 720) {
	  A-=720;
	}
      } else if(j_state->j1 & JOYPAD_DOWN) {
	A-=2;
	if(A < 0) {
	  A+=720;
	}
      }
      if(j_state->j1 & JOYPAD_LEFT) {
	B+=2;
	if(B > 720) {
	  B-=720;
	}
      } else if(j_state->j1 & JOYPAD_RIGHT) {
	B-=2;
	if(B < 0) {
	  B+=720;
	}
      }
      if(j_state->j1 & JOYPAD_L) {
	C+=2;
	if(C > 720) {
	  C-=720;
	}
      } else if(j_state->j1 & JOYPAD_R) {
	C-=2;
	if(C < 0) {
	  C+=720;
	}
      }
      if(j_state->j1 & JOYPAD_PAUSE) {
	pause = 0;
      }
    } else {
      if(j_state->j1 & JOYPAD_PAUSE) {
	pause = 0xffff;
      }
    }
#endif
  }
#endif

#if(TEST==0)
  clear_screen(frame1);
  attach_sprite_to_display_at_layer(frame_sprite,d,1);
  
  symm.texture = texture;
  for(;;) {
    vsync();
    SET_BG(BLUE);
    symm.vertices[0].u += 0x10000;
    symm.vertices[1].u += 0x10000;
    symm.vertices[2].u += 0x10000;
    symm.vertices[3].u += 0x10000;
    if(symm.vertices[0].u == 64<<16) {
      symm.vertices[0].u = 0;
      symm.vertices[1].u = 63<<16;
      symm.vertices[2].u = 63<<16;
      symm.vertices[3].u = 0;
    }
    render_polygon_list_and_wait(frame1,&symm,NO_CLR_SCREEN);
    //      }
    SET_BG(0);
  }
#endif

#if(TEST==1)
  FILE *console = open_console(d,0,0,0);

  fprintf(console,"Hello\n"); 
  fprintf(console,"Press B to see some polygons\n"); 
  fprintf(console,"Beware: no clipping!!\n"); 
  fprintf(console,"A/C: change active vertex\n");
  fprintf(console,"Left/Right/Up/Down: move active vertex\n");
  fprintf(console,"B+Up/Down: change intensity of active vertex\n");
  fprintf(console,"B+Left/Right: change depth of active vertex\n");
  fprintf(console,"*/#: change intensity of texture\n");

#if(DEBUG)

  fprintf(console,"Press B to clear the buffers\n");
  fprintf(console,"BASE ADDRESS = %08x = %08x\n",frame1->data,frame_data);
  unsigned long flags = *((unsigned long *)frame1);
  fprintf(console,"FLAGS = %b = %08x\n",flags,flags);
  fprintf(console,"HEIGHT = %d\n",frame1->height);  
  fprintf(console,"WIDTH = %d\n",frame1->width);  
 
  for(;;) {
    vsync();
    read_joypad_state(j_state);
    if(j_state->j1 & JOYPAD_B) {
      break;
    }
  }

  for(;;) {
    vsync();
    read_joypad_state(j_state);
    if(!(j_state->j1 & JOYPAD_B)) {
      break;
    }
  }

  int phase = 0;

  for(phase = 0; phase < 3; phase++) {

    switch(phase) {
    case 0:
      fprintf(console,"1-simple clear with 68k...\n");
      bzero(frame1->data,320*240*2);
      break;
    case 1:
      fprintf(console,"2-simple clear with blitter...\n");
      //      asm("illegal");      
      clear_screen(frame1);
      break;
    case 2:
      fprintf(console,"3-Zbuffer clear with blitter...\n");
      //      asm("illegal");      
      clear_zbuffered_screen(frame1);
      break;
    }

    fprintf(console,"Press B to continue\n");
    
    for(;;) {
      vsync();
      read_joypad_state(j_state);
      if(j_state->j1 & JOYPAD_B) {
	break;
      }
    }

    for(;;) {
      vsync();
      read_joypad_state(j_state);
      if(!(j_state->j1 & JOYPAD_B)) {
	break;
      }
    }
  }

#else
  fprintf(console,"Press B to continue\n");
  
  for(;;) {
    vsync();
    read_joypad_state(j_state);
    if(j_state->j1 & JOYPAD_B) {
      break;
    }
  }
  
  for(;;) {
    vsync();
    read_joypad_state(j_state);
    if(!(j_state->j1 & JOYPAD_B)) {
      break;
    }
  }
#endif

  fclose(console);

  attach_sprite_to_display_at_layer(frame_sprite,d,1);

  screen *phys = frame1;
  screen *log = frame2;
  screen *tmp = phys;

  clear_zbuffered_screen(frame1);

  int idx = 0;
  unsigned long joy = 0;
  for(;;) {
    vsync();
    read_joypad_state(j_state);
    set_polygons();

    SET_BG(MAGENTA);
    //    clear_zbuffered_screen(phys);
    SET_BG(RED);
    //    p3.next = NULL;
    render_polygon_list_and_wait(phys,&p6,CLR_Z_SCREEN);
    //    render_polygon_list_and_wait(phys,&ptest);
    SET_BG(0);
    vertex *v = &vertices[idx];
    unsigned long o_joy = joy;
    joy = j_state->j1;
    unsigned long n_joy = joy;
    n_joy &= ~o_joy; 
    if(n_joy & JOYPAD_C) {
      idx++;
      if(idx >= NB_VERTICES) {
	idx = 0;
      }
    } else if(n_joy & JOYPAD_A) {
      idx--;
      if(idx < 0) {
	idx = NB_VERTICES-1;
      }
    }
    if(j_state->j1 & JOYPAD_B) {
      if(j_state->j1 & JOYPAD_DOWN) {
	v->i += 0x10000;
      } else if(j_state->j1 & JOYPAD_UP) {
	v->i -= 0x10000;
      }
      if(j_state->j1 & JOYPAD_LEFT) {
	v->z -= 0x8000;
      } else if(j_state->j1 & JOYPAD_RIGHT) {
	v->z += 0x8000;
      }

    } else {
      if(j_state->j1 & JOYPAD_DOWN) {
	v->y += 0x8000;
      } else if(j_state->j1 & JOYPAD_UP) {
	v->y -= 0x8000;
      }
      if(j_state->j1 & JOYPAD_LEFT) {
	v->x -= 0x8000;
      } else if(j_state->j1 & JOYPAD_RIGHT) {
	v->x += 0x8000;
      }
    }
    if(j_state->j1 & JOYPAD_STAR) {
      p3.param -= 0x8000;
    } else if(j_state->j1 & JOYPAD_SHARP) {
      p3.param += 0x8000;
    }

    tmp = phys;
    phys = log;
    log = tmp;
    wait_display_refresh();
    frame_sprite->data = phys->data;
  }    
#endif

  return 0;
}

